classdef Apriltag4Matlab
% A matlab loader for apriltag4matlab.jar
%
% author: Chen Feng <simbaforrest at gmail dot com>

  %% static methods
  methods(Static)
    function jarpath = getJavaPath
      mydir=fileparts(mfilename('fullpath'));
      jarpath = fullfile(mydir,'apriltag4matlab.jar');
    end
    
    function install
      javaaddpath(Apriltag4Matlab.getJavaPath);
      persistent runned;
      mlock;
      if isempty(runned)
        runned=true;
        Apriltag4Matlab.clearOldTmp;
      end
    end
    
    function clearOldTmp
      tmpdir=char(java.lang.System.getProperty('java.io.tmpdir'));
      tmpfiles=dir(fullfile(tmpdir,'javacpp*'));
      if ~isempty(tmpfiles)
        fprintf('[Apriltag4Matlab.clearOldTmp] Clearing the tmp dll files from last time...\n');
      end
      for i=1:length(tmpfiles)
        tmp=fullfile(tmpdir,tmpfiles(i).name);
        fprintf('trying to clear: %s\n',tmp);
        try
          rmdir(tmp,'s');
          fprintf('\tcleared!\n');
        catch err
          fprintf('\t...but failed!\n');
        end
      end
    end
    
    function uninstall
      javarmpath(Apriltag4Matlab.getJavaPath);
    end
  end
end